Imports Microsoft.VisualBasic
Imports System
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.WebEdition

Partial Public Class ClickEventOnAMarker : Inherits System.Web.UI.Page
    Private ReadOnly markerIcons As String() = New String() {"marker_blue.gif", "marker.gif", "marker_gold.gif", "marker_green.gif"}

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If (Not Page.IsPostBack) Then
            Map1.MapBackground.BackgroundBrush = New GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"))
            Map1.CurrentExtent = New RectangleShape(-131.22, 55.05, -54.03, 16.91)
            Map1.MapUnit = GeographyUnit.DecimalDegree

            Dim worldMapKitWmsWebOverlay As New WorldMapKitWmsWebOverlay()
            Map1.CustomOverlays.Add(worldMapKitWmsWebOverlay)

            Dim inMemoryMarkerOverlay As New InMemoryMarkerOverlay("InMemoryMarkerOverlay")

            'Add column to InMemoryMarkerOverlay's FeatureSource
            Dim locIDColumn As New FeatureSourceColumn("LocId")
            inMemoryMarkerOverlay.Columns.Add(locIDColumn)

            Dim kansasFeature As New Feature(-94.48242, 38.75977)
            'Add VolumeValue to feature
            kansasFeature.ColumnValues.Add("LocId", "The Location ID of the feature")
            inMemoryMarkerOverlay.Features.Add("Kansas", kansasFeature)

            inMemoryMarkerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = New WebImage("../../theme/default/img/marker_blue.gif", 21, 25)
            inMemoryMarkerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
            Map1.CustomOverlays.Add(inMemoryMarkerOverlay)

            AddHandler inMemoryMarkerOverlay.Click, AddressOf markerOverlay_Click
        End If
    End Sub

    Private Sub markerOverlay_Click(ByVal sender As Object, ByVal e As MarkerOverlayClickEventArgs)
        Dim times As Integer
        If ViewState("ClickTimes") IsNot Nothing Then
            times = CInt(ViewState("ClickTimes"))
            times += 1
        Else
            times = 1
        End If

        Dim iconIndex As Integer = times Mod 4 + 1
        If iconIndex >= 4 Then
            iconIndex -= 4
        End If

        Dim iconPath As String = "../../theme/default/img/" & markerIcons(iconIndex)

        Dim inMemoryMarkerOverlay As InMemoryMarkerOverlay = DirectCast(Map1.CustomOverlays("InMemoryMarkerOverlay"), InMemoryMarkerOverlay)
        inMemoryMarkerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageVirtualPath = iconPath

        Label1.Text = [String].Format("You have clicked the marker <span style='color:red;font-weight:bolder;font-size:15;'>{0}</span> time(s)", times)
        ViewState("ClickTimes") = times

        inMemoryMarkerOverlay.FeatureSource.Open()
        Dim testFeature As Feature = inMemoryMarkerOverlay.FeatureSource.GetFeatureById(e.FeatureId, New String(0) {"LocId"})
        'Check this string for the value from the LocId column
        Dim textString As String = testFeature.ColumnValues("LocId")


    End Sub
End Class
